{
GMFunctions unit

  ES: unidad con funciones de caracter general
  EN: unit with a general functions

=========================================================================
History:

ver 0.1.7
  ES:
    cambio: aadidas nuevas funciones de transformacin de tipos
  EN:
    change: added new functions of transformation types

ver 0.1.6
  ES:
    nuevo: nueva clase TTransform con transformaciones xxxToStr y StrToxxx
  EN:
    new: new TTransform class with xxxToStr and StrToxxx transformations

ver 0.1.5
  ES: primera versin
  EN: first version
=========================================================================
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras,
  ampliaciones, errores y/o cualquier otro tipo de sugerencia, envame un correo a:
  gmlib@cadetill.com

IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
  errors and/or any another type of suggestion, please send me a mail to:
  gmlib@cadetill.com
=========================================================================

Copyright () 2012, by Xavier Martinez (cadetill)

@author Xavier Martinez (cadetill)
@web  http://www.cadetill.com
}
unit GMFunctions;

interface

uses
  GMConstants;

type
  // ES: s, lo s, ests funciones estn implementadas en la clase TPath de la
  //   unit IOUtils, pero como en versiones antiguas de Delphi esta clase no existe,
  //   las he "copiado" aqu para poderlas usar
  // EN: yes, I know, these functions are implemented in the TPath class of the
  //   unit IOUtils, but as in the old versions of Delphi this class does not exist,
  //   I have "copied" it here to can be used.
  TPath = class
  public
    class function GetTempPath: string;
    class function GetTempFileName: string;
  end;

  TTransform = class
  public
    class function RegionToStr(Region: TRegion): string;
    class function RegionToStr2(Region: TRegion): string;
    class function LangCodeToStr(LangCode: TLangCode): string;
    class function TravelModeToStr(TravelMode: TTravelMode): string;
    class function UnitSystemToStr(UnitSystem: TUnitSystem): string;
    class function GeocoderLocationTypeToStr(GeocoderLocationType: TGeocoderLocationType): string;
    class function GeocoderStatusToStr(GeocoderStatus: TGeocoderStatus): string;
    class function LangCodeToStr2(LangCode: TLangCode): string;
    class function LabelColorToStr(LabelColor: TLabelColor): string;
    class function TemperatureUnitToStr(TemperatureUnit: TTemperatureUnit): string;
    class function WindSpeedUnitToStr(WindSpeedUnit: TWindSpeedUnit): string;
    class function DirectionsStatusToStr(DirectionsStatus: TDirectionsStatus): string;
    class function VehicleTypeToStr(VehicleType: TVehicleType): string;
    class function SymbolPathToStr(SymbolPath: TSymbolPath): string;
    class function MeasureToStr(Measure: TMeasure): string;
    class function MarkerTypeToStr(MarkerType: TMarkerType): string;
    class function StyledIconToStr(StyledIcon: TStyledIcon): string;
    class function ElevationTypeToStr(ElevationType: TElevationType): string;
    class function ElevationStatusToStr(ElevationStatus: TElevationStatus): string;

    class function StrToUnitSystem(UnitSystem: string): TUnitSystem;
    class function StrToTravelMode(TravelMode: string): TTravelMode;
    class function StrToRegion2(Region: string): TRegion;
    class function StrToGeocoderLocationType(GeocoderLocationType: string): TGeocoderLocationType;
    class function StrToGeocoderStatus(GeocoderStatus: string): TGeocoderStatus;
    class function StrToLangCode2(LangCode: string): TLangCode;
    class function StrToLabelColor(LabelColor: string): TLabelColor;
    class function StrToTemperatureUnit(TemperatureUnit: string): TTemperatureUnit;
    class function StrToWindSpeedUnit(WindSpeedUnit: string): TWindSpeedUnit;
    class function StrToDirectionsStatus(DirectionsStatus: string): TDirectionsStatus;
    class function StrToVehicleType(VehicleType: string): TVehicleType;
    class function StrToSymbolPath(SymbolPath: string): TSymbolPath;
    class function StrToMeasure(Measure: string): TMeasure;
    class function StrToMarkerType(MarkerType: string): TMarkerType;
    class function StrToStyledIcon(StyledIcon: string): TStyledIcon;
    class function StrToElevationType(ElevationType: string): TElevationType;
    class function StrToElevationStatus(ElevationStatus: string): TElevationStatus;
  end;

implementation

uses
  SysUtils, Windows, StrUtils, TypInfo;

{ TPath }

class function TPath.GetTempPath: string;
var
  Len: Integer;
begin
  Result := ''; // DO NOT LOCALIZE
  SetLastError(ERROR_SUCCESS);

  // get memory for the buffer retaining the temp path (plus null-termination)
  Len := Windows.GetTempPath(0, nil);
  SetLength(Result, Len - 1);
  if Windows.GetTempPath(Len, PChar(Result)) = 0 then
    Result := '';
end;

class function TPath.GetTempFileName: string;
var
  TempPath: string;
  ErrCode: Cardinal;
  P: PChar;
begin
  TempPath := TPath.GetTempPath;
  GetMem(P, MAX_PATH);

  SetLastError(ERROR_SUCCESS);
  ErrCode := Windows.GetTempFileName(PChar(TempPath), 'tmp', 0, P); // DO NOT LOCALIZE
  if ErrCode = 0 then
    raise Exception.Create(SysErrorMessage(GetLastError));

  Result := StrPas(P);
  FreeMem(P);
end;

{ TTransform }

class function TTransform.DirectionsStatusToStr(
  DirectionsStatus: TDirectionsStatus): string;
begin
  Result := GetEnumName(TypeInfo(TDirectionsStatus), Ord(DirectionsStatus));
end;

class function TTransform.ElevationStatusToStr(
  ElevationStatus: TElevationStatus): string;
begin
  Result := GetEnumName(TypeInfo(TElevationStatus), Ord(ElevationStatus));
end;

class function TTransform.ElevationTypeToStr(
  ElevationType: TElevationType): string;
begin
  Result := GetEnumName(TypeInfo(TElevationType), Ord(ElevationType));
end;

class function TTransform.GeocoderLocationTypeToStr(
  GeocoderLocationType: TGeocoderLocationType): string;
begin
  Result := GetEnumName(TypeInfo(TGeocoderLocationType), Ord(GeocoderLocationType));
end;

class function TTransform.GeocoderStatusToStr(
  GeocoderStatus: TGeocoderStatus): string;
begin
  Result := GetEnumName(TypeInfo(TGeocoderStatus), Ord(GeocoderStatus));
end;

class function TTransform.LabelColorToStr(LabelColor: TLabelColor): string;
begin
  Result := GetEnumName(TypeInfo(TLabelColor), Ord(LabelColor));
end;

class function TTransform.LangCodeToStr(LangCode: TLangCode): string;
begin
  case LangCode of
    lcARABIC: Result := 'ar';
    lcBASQUE: Result := 'eu';
    lcBENGALI: Result := 'bn';
    lcBULGARIAN: Result := 'bg';
    lcCATALAN: Result := 'ca';
    lcCHINESE_SIMPLIFIED: Result := 'zh-CN';
    lcCHINESE_TRADITIONAL: Result := 'zh-TW';
    lcCROATIAN: Result := 'hr';
    lcCZECH: Result := 'cs';
    lcDANISH: Result := 'da';
    lcDUTCH: Result := 'nl';
    lcENGLISH: Result := 'en';
    lcENGLISH_AUSTRALIAN: Result := 'en-AU';
    lcENGLISH_GREAT_BRITAIN: Result := 'en-GB';
    lcFARSI: Result := 'fa';
    lcFILIPINO: Result := 'fil';
    lcFINNISH: Result := 'fi';
    lcFRENCH: Result := 'fr';
    lcGALICIAN: Result := 'gl';
    lcGERMAN: Result := 'de';
    lcGREEK: Result := 'el';
    lcGUJARATI: Result := 'gu';
    lcHEBREW: Result := 'iw';
    lcHINDI: Result := 'hi';
    lcHUNGARIAN: Result := 'hu';
    lcINDONESIAN: Result := 'id';
    lcITALIAN: Result := 'it';
    lcJAPANESE: Result := 'ja';
    lcKANNADA: Result := 'kn';
    lcKOREAN: Result := 'ko';
    lcLATVIAN: Result := 'lv';
    lcLITHUANIAN: Result := 'lt';
    lcMALAYALAM: Result := 'ml';
    lcMARATHI: Result := 'mr';
    lcNORWEGIAN: Result := 'no';
    lcPOLISH: Result := 'pl';
    lcPORTUGUESE: Result := 'pt';
    lcPORTUGUESE_BRAZIL: Result := 'pt-BR';
    lcPORTUGUESE_PORTUGAL: Result := 'pt-PT';
    lcROMANIAN: Result := 'ro';
    lcRUSSIAN: Result := 'ru';
    lcSERBIAN: Result := 'sr';
    lcSLOVAK: Result := 'sk';
    lcSLOVENIAN: Result := 'sl';
    lcSPANISH: Result := 'es';
    lcSWEDISH: Result := 'sv';
    lcTAGALOG: Result := 'tl';
    lcTAMIL: Result := 'ta';
    lcTELUGU: Result := 'te';
    lcTHAI: Result := 'th';
    lcTURKISH: Result := 'tr';
    lcUKRAINIAN: Result := 'uk';
    lcVIETNAMESE: Result := 'vi';
    else Result := '';
  end;
end;

class function TTransform.LangCodeToStr2(LangCode: TLangCode): string;
begin
  Result := GetEnumName(TypeInfo(TLangCode), Ord(LangCode));
end;

class function TTransform.MarkerTypeToStr(MarkerType: TMarkerType): string;
begin
  Result := GetEnumName(TypeInfo(TMarkerType), Ord(MarkerType));
end;

class function TTransform.MeasureToStr(Measure: TMeasure): string;
begin
  Result := GetEnumName(TypeInfo(TMeasure), Ord(Measure));
end;

class function TTransform.RegionToStr(Region: TRegion): string;
begin
  case Region of
    rAFGHANISTAN: Result := 'af';
    rALAND: Result := 'ax';
    rALBANIA: Result := 'al';
    rALGERIA: Result := 'dz';
    rAMERICAN_SAMOA: Result := 'as';
    rANDORRA: Result := 'ad';
    rANGOLA: Result := 'ao';
    rANGUILLA: Result := 'ai';
    rANTARCTICA: Result := 'aq';
    rANTIGUA_AND_BARBUDA: Result := 'ag';
    rARGENTINA: Result := 'ar';
    rARMENIA: Result := 'am';
    rARUBA: Result := 'aw';
    rASCENSION_ISLAND: Result := 'ac';
    rAUSTRALIA: Result := 'au';
    rAUSTRIA: Result := 'at';
    rAZERBAIJAN: Result := 'az';
    rBAHAMAS: Result := 'bs';
    rBAHRAIN: Result := 'bh';
    rBANGLADESH: Result := 'bd';
    rBARBADOS: Result := 'bb';
    rBELARUS: Result := 'by';
    rBELGIUM: Result := 'be';
    rBELIZE: Result := 'bz';
    rBENIN: Result := 'bj';
    rBERMUDA: Result := 'bm';
    rBHUTAN: Result := 'bt';
    rBOLIVIA: Result := 'bo';
    rBOSNIA_AND_HERZEGOVINA: Result := 'ba';
    rBOTSWANA: Result := 'bw';
    rBRAZIL: Result := 'br';
    rBRITISH_INDIAN_OCEAN_TERRITORY: Result := 'io';
    rBRITISH_VIRGIN_ISLANDS: Result := 'vg';
    rBRUNEI: Result := 'bn';
    rBULGARIA: Result := 'bg';
    rBURKINA_FASO: Result := 'bf';
    rBURUNDI: Result := 'bi';
    rCAMBODIA: Result := 'kh';
    rCAMEROON: Result := 'cm';
    rCANADA: Result := 'ca';
    rCAPE_VERDE: Result := 'cv';
    rCAYMAN_ISLANDS: Result := 'ky';
    rCENTRAL_AFRICAN_REPUBLIC: Result := 'cf';
    rCHAD: Result := 'td';
    rCHILE: Result := 'cl';
    rCHRISTMAS_ISLAND: Result := 'cx';
    rCOCOS_KEELING_ISLANDS: Result := 'cc';
    rCOLOMBIA: Result := 'co';
    rCOMOROS: Result := 'km';
    rCOOK_ISLANDS: Result := 'ck';
    rCOSTA_RICA: Result := 'cr';
    rCOTE_D_IVOIRE: Result := 'ci';
    rCROATIA: Result := 'hr';
    rCUBA: Result := 'cu';
    rCYPRUS: Result := 'cy';
    rCZECH_REPUBLIC: Result := 'cz';
    rDEMOCRATIC_PEOPLE_S_REPUBLIC_OF_KOREA: Result := 'kp';
    rDEMOCRATIC_REPUBLIC_OF_THE_CONGO: Result := 'cd';
    rDENMARK: Result := 'dk';
    rDJIBOUTI: Result := 'dj';
    rDOMINICA: Result := 'dm';
    rDOMINICAN_REPUBLIC: Result := 'do';
    rEAST_TIMOR: Result := 'tl';
    rECUADOR: Result := 'ec';
    rEGYPT: Result := 'eg';
    rEL_SALVADOR: Result := 'sv';
    rEQUATORIAL_GUINEA: Result := 'gq';
    rERITREA: Result := 'er';
    rESTONIA: Result := 'ee';
    rETHIOPIA: Result := 'et';
    rEUROPEAN_UNION: Result := 'eu';
    rFALKLAND_ISLANDS: Result := 'fk';
    rFAROE_ISLANDS: Result := 'fo';
    rFEDERATED_STATES_OF_MICRONESIA: Result := 'fm';
    rFIJI: Result := 'fj';
    rFINLAND: Result := 'fi';
    rFRANCE: Result := 'fr';
    rFRENCH_GUIANA: Result := 'gf';
    rFRENCH_POLYNESIA: Result := 'pf';
    rFRENCH_SOUTHERN_AND_ANTARCTIC_LANDS: Result := 'tf';
    rGABON: Result := 'ga';
    rGEORGIA: Result := 'ge';
    rGERMANY: Result := 'de';
    rGHANA: Result := 'gh';
    rGIBRALTAR: Result := 'gi';
    rGREECE: Result := 'gr';
    rGREENLAND: Result := 'gl';
    rGRENADA: Result := 'gd';
    rGUADELOUPE: Result := 'gp';
    rGUAM: Result := 'gu';
    rGUATEMALA: Result := 'gt';
    rGUERNSEY: Result := 'gg';
    rGUINEA: Result := 'gn';
    rGUINEA_BISSAU: Result := 'gw';
    rGUYANA: Result := 'gy';
    rHAITI: Result := 'ht';
    rHEARD_ISLAND_AND_MCDONALD_ISLANDS: Result := 'hm';
    rHONDURAS: Result := 'hn';
    rHONG_KONG: Result := 'hk';
    rHUNGARY: Result := 'hu';
    rICELAND: Result := 'is';
    rINDIA: Result := 'in';
    rINDONESIA: Result := 'id';
    rIRAN: Result := 'ir';
    rIRAQ: Result := 'iq';
    rISLE_OF_MAN: Result := 'im';
    rISRAEL: Result := 'il';
    rITALY: Result := 'it';
    rJAMAICA: Result := 'jm';
    rJAPAN: Result := 'jp';
    rJERSEY: Result := 'je';
    rJORDAN: Result := 'jo';
    rKAZAKHSTAN: Result := 'kz';
    rKENYA: Result := 'ke';
    rKIRIBATI: Result := 'ki';
    rKUWAIT: Result := 'kw';
    rKYRGYZSTAN: Result := 'kg';
    rLAOS: Result := 'la';
    rLATVIA: Result := 'lv';
    rLEBANON: Result := 'lb';
    rLESOTHO: Result := 'ls';
    rLIBERIA: Result := 'lr';
    rLIBYA: Result := 'ly';
    rLIECHTENSTEIN: Result := 'li';
    rLITHUANIA: Result := 'lt';
    rLUXEMBOURG: Result := 'lu';
    rMACAU: Result := 'mo';
    rMACEDONIA: Result := 'mk';
    rMADAGASCAR: Result := 'mg';
    rMALAWI: Result := 'mw';
    rMALAYSIA: Result := 'my';
    rMALDIVES: Result := 'mv';
    rMALI: Result := 'ml';
    rMALTA: Result := 'mt';
    rMARSHALL_ISLANDS: Result := 'mh';
    rMARTINIQUE: Result := 'mq';
    rMAURITANIA: Result := 'mr';
    rMAURITIUS: Result := 'mu';
    rMAYOTTE: Result := 'yt';
    rMEXICO: Result := 'mx';
    rMOLDOVA: Result := 'md';
    rMONACO: Result := 'mc';
    rMONGOLIA: Result := 'mn';
    rMONTENEGRO: Result := 'me';
    rMONTSERRAT: Result := 'ms';
    rMOROCCO: Result := 'ma';
    rMOZAMBIQUE: Result := 'mz';
    rMYANMAR: Result := 'mm';
    rNAMIBIA: Result := 'na';
    rNAURU: Result := 'nr';
    rNEPAL: Result := 'np';
    rNETHERLANDS: Result := 'nl';
    rNETHERLANDS_ANTILLES: Result := 'an';
    rNEW_CALEDONIA: Result := 'nc';
    rNEW_ZEALAND: Result := 'nz';
    rNICARAGUA: Result := 'ni';
    rNIGER: Result := 'ne';
    rNIGERIA: Result := 'ng';
    rNIUE: Result := 'nu';
    rNORFOLK_ISLAND: Result := 'nf';
    rNORTHERN_MARIANA_ISLANDS: Result := 'mp';
    rNORWAY: Result := 'no';
    rOMAN: Result := 'om';
    rPAKISTAN: Result := 'pk';
    rPALAU: Result := 'pw';
    rPALESTINIAN_TERRITORIES: Result := 'ps';
    rPANAMA: Result := 'pa';
    rPAPUA_NEW_GUINEA: Result := 'pg';
    rPARAGUAY: Result := 'py';
    rPEOPLE_S_REPUBLIC_OF_CHINA: Result := 'cn';
    rPERU: Result := 'pe';
    rPHILIPPINES: Result := 'ph';
    rPITCAIRN_ISLANDS: Result := 'pn';
    rPOLAND: Result := 'pl';
    rPORTUGAL: Result := 'pt';
    rPUERTO_RICO: Result := 'pr';
    rQATAR: Result := 'qa';
    rREPUBLIC_OF_IRELAND_AND_NORTHERN_IRELAND: Result := 'ie';
    rREPUBLIC_OF_KOREA: Result := 'kr';
    rREPUBLIC_OF_THE_CONGO: Result := 'cg';
    rREUNION: Result := 're';
    rROMANIA: Result := 'ro';
    rRUSSIA: Result := 'ru';
    rRWANDA: Result := 'rw';
    rSAINT_HELENA: Result := 'sh';
    rSAINT_KITTS_AND_NEVIS: Result := 'kn';
    rSAINT_LUCIA: Result := 'lc';
    rSAINT_VINCENT_AND_THE_GRENADINES: Result := 'vc';
    rSAINT_PIERRE_AND_MIQUELON: Result := 'pm';
    rSAMOA: Result := 'ws';
    rSAN_MARINO: Result := 'sm';
    rSAO_TOME_AND_PRINCIPE: Result := 'st';
    rSAUDI_ARABIA: Result := 'sa';
    rSENEGAL: Result := 'sn';
    rSERBIA: Result := 'rs';
    rSEYCHELLES: Result := 'sc';
    rSIERRA_LEONE: Result := 'sl';
    rSINGAPORE: Result := 'sg';
    rSLOVAKIA: Result := 'sk';
    rSLOVENIA: Result := 'si';
    rSOLOMON_ISLANDS: Result := 'sb';
    rSOMALIA: Result := 'so';
    rSOUTH_AFRICA: Result := 'za';
    rSOUTH_GEORGIA_AND_THE_SOUTH_SANDWICH_ISLANDS: Result := 'gs';
    rSOUTH_SUDAN: Result := 'ss';
    rSPAIN: Result := 'es';
    rSRI_LANKA: Result := 'lk';
    rSUDAN: Result := 'sd';
    rSURINAME: Result := 'sr';
    rSWAZILAND: Result := 'sz';
    rSWEDEN: Result := 'se';
    rSWITZERLAND: Result := 'ch';
    rSYRIA: Result := 'sy';
    rTAIWAN: Result := 'tw';
    rTAJIKISTAN: Result := 'tj';
    rTANZANIA: Result := 'tz';
    rTHAILAND: Result := 'th';
    rTHE_GAMBIA: Result := 'gm';
    rTOGO: Result := 'tg';
    rTOKELAU: Result := 'tk';
    rTONGA: Result := 'to';
    rTRINIDAD_AND_TOBAGO: Result := 'tt';
    rTUNISIA: Result := 'tn';
    rTURKEY: Result := 'tr';
    rTURKMENISTAN: Result := 'tm';
    rTURKS_AND_CAICOS_ISLANDS: Result := 'tc';
    rTUVALU: Result := 'tv';
    rUGANDA: Result := 'ug';
    rUKRAINE: Result := 'ua';
    rUNITED_ARAB_EMIRATES: Result := 'ae';
    rUNITED_KINGDOM: Result := 'uk';
    rUNITED_STATES_OF_AMERICA: Result := 'us';
    rUNITED_STATES_VIRGIN_ISLANDS: Result := 'vi';
    rURUGUAY: Result := 'uy';
    rUZBEKISTAN: Result := 'uz';
    rVANUATU: Result := 'vu';
    rVATICAN_CITY: Result := 'va';
    rVENEZUELA: Result := 've';
    rVIETNAM: Result := 'vn';
    rWALLIS_AND_FUTUNA: Result := 'wf';
    rWESTERN_SAHARA: Result := 'eh';
    rYEMEN: Result := 'ye';
    rZAMBIA: Result := 'zm';
    rZIMBABWE: Result := 'zw';
    else Result := '';
  end;
end;

class function TTransform.RegionToStr2(Region: TRegion): string;
begin
  Result := GetEnumName(TypeInfo(TRegion), Ord(Region));
end;

class function TTransform.StrToDirectionsStatus(
  DirectionsStatus: string): TDirectionsStatus;
begin
  Result := TDirectionsStatus(GetEnumValue(TypeInfo(TDirectionsStatus), DirectionsStatus));
end;

class function TTransform.StrToElevationStatus(
  ElevationStatus: string): TElevationStatus;
begin
  Result := TElevationStatus(GetEnumValue(TypeInfo(TElevationStatus), ElevationStatus));
end;

class function TTransform.StrToElevationType(
  ElevationType: string): TElevationType;
begin
  Result := TElevationType(GetEnumValue(TypeInfo(TElevationType), ElevationType));
end;

class function TTransform.StrToGeocoderLocationType(
  GeocoderLocationType: string): TGeocoderLocationType;
begin
  Result := TGeocoderLocationType(GetEnumValue(TypeInfo(TGeocoderLocationType), GeocoderLocationType));
end;

class function TTransform.StrToGeocoderStatus(
  GeocoderStatus: string): TGeocoderStatus;
begin
  Result := TGeocoderStatus(GetEnumValue(TypeInfo(TGeocoderStatus), GeocoderStatus));
end;

class function TTransform.StrToLabelColor(LabelColor: string): TLabelColor;
begin
  Result := TLabelColor(GetEnumValue(TypeInfo(TLabelColor), LabelColor));
end;

class function TTransform.StrToLangCode2(LangCode: string): TLangCode;
begin
  Result := TLangCode(GetEnumValue(TypeInfo(TLangCode), LangCode));
end;

class function TTransform.StrToMarkerType(MarkerType: string): TMarkerType;
begin
  Result := TMarkerType(GetEnumValue(TypeInfo(TMarkerType), MarkerType));
end;

class function TTransform.StrToMeasure(Measure: string): TMeasure;
begin
  Result := TMeasure(GetEnumValue(TypeInfo(TMeasure), Measure));
end;

class function TTransform.StrToRegion2(Region: string): TRegion;
begin
  Result := TRegion(GetEnumValue(TypeInfo(TRegion), Region));
end;

class function TTransform.StrToStyledIcon(StyledIcon: string): TStyledIcon;
begin
  Result := TStyledIcon(GetEnumValue(TypeInfo(TStyledIcon), StyledIcon));
end;

class function TTransform.StrToSymbolPath(SymbolPath: string): TSymbolPath;
begin
  Result := TSymbolPath(GetEnumValue(TypeInfo(TSymbolPath), SymbolPath));
end;

class function TTransform.StrToTemperatureUnit(
  TemperatureUnit: string): TTemperatureUnit;
begin
  Result := TTemperatureUnit(GetEnumValue(TypeInfo(TTemperatureUnit), TemperatureUnit));
end;

class function TTransform.StrToTravelMode(TravelMode: string): TTravelMode;
begin
  Result := TTravelMode(GetEnumValue(TypeInfo(TTravelMode), TravelMode));
end;

class function TTransform.StrToUnitSystem(UnitSystem: string): TUnitSystem;
begin
  Result := TUnitSystem(GetEnumValue(TypeInfo(TUnitSystem), UnitSystem));
end;

class function TTransform.StrToVehicleType(VehicleType: string): TVehicleType;
begin
  Result := TVehicleType(GetEnumValue(TypeInfo(TVehicleType), VehicleType));
end;

class function TTransform.StrToWindSpeedUnit(
  WindSpeedUnit: string): TWindSpeedUnit;
begin
  Result := TWindSpeedUnit(GetEnumValue(TypeInfo(TWindSpeedUnit), WindSpeedUnit));
end;

class function TTransform.StyledIconToStr(StyledIcon: TStyledIcon): string;
begin
  Result := GetEnumName(TypeInfo(TStyledIcon), Ord(StyledIcon));
end;

class function TTransform.SymbolPathToStr(SymbolPath: TSymbolPath): string;
begin
  Result := GetEnumName(TypeInfo(TSymbolPath), Ord(SymbolPath));
end;

class function TTransform.TemperatureUnitToStr(
  TemperatureUnit: TTemperatureUnit): string;
begin
  Result := GetEnumName(TypeInfo(TTemperatureUnit), Ord(TemperatureUnit));
end;

class function TTransform.TravelModeToStr(TravelMode: TTravelMode): string;
begin
  Result := GetEnumName(TypeInfo(TTravelMode), Ord(TravelMode));
end;

class function TTransform.UnitSystemToStr(UnitSystem: TUnitSystem): string;
begin
  Result := GetEnumName(TypeInfo(TUnitSystem), Ord(UnitSystem));
end;

class function TTransform.VehicleTypeToStr(VehicleType: TVehicleType): string;
begin
  Result := GetEnumName(TypeInfo(TVehicleType), Ord(VehicleType));
end;

class function TTransform.WindSpeedUnitToStr(
  WindSpeedUnit: TWindSpeedUnit): string;
begin
  Result := GetEnumName(TypeInfo(TWindSpeedUnit), Ord(WindSpeedUnit));
end;

end.
