{
unit Lang

  ES: unidad para facilitar el cambio de idioma en los errores
  EN: unit to facilitate the change of language of the errors

=========================================================================
History:

ver 0.1.7
  ES:
    nuevo: aadido el idioma portugus (gracias Moacir Fortes)
  EN:
    new: added french portuguese (thanks Moacir Fortes)

ver 0.1.6
  ES:
    nuevo: aadido el idioma francs (gracias Stphane)
  EN:
    new: added french language (thanks Stphane)

ver 0.1:
  ES: primera versin
  EN: first version
=========================================================================
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras,
  ampliaciones, errores y/o cualquier otro tipo de sugerencia, envame un correo a:
  gmlib@cadetill.com

IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
  errors and/or any another type of suggestion, please send me a mail to:
  gmlib@cadetill.com
=========================================================================

Copyright () 2011, by Xavier Martinez (cadetill)

@author Xavier Martinez (cadetill)
@web  http://www.cadetill.com
}
unit Lang;

interface

uses
  GMConstants;

const
  Lang_ESP: array[0..14] of string = (
      'No se ha especificado el objeto WebBrowser',    // 0
      'Pgina inicial aun no cargada',      // 1
      'El mapa todava no ha sido creado',  // 2
      'No est activo',                     // 3
      'No se ha podido cargar el recurso',  // 4
      'Este objeto no tiene relacin en JavaScript',  // 5
      'Id de JavaScript incorrecto',        // 6
      'Id de JavaScript inexistente',       // 7
      'Nmero de parmetros incorrecto',    // 8
      'Tipo de parmetro incorrecto',       // 9
      'Valor de parmetro incorrecto',      // 10
      'ndice fuera de rango',              // 11
      'Mapa no asignado',                   // 12
      'El fichero no existe',               // 13
      'El nmero de columna es incorrecto'  // 14
      );

  Lang_ENG: array[0..14] of string = (
      'WebBrowser not defined',             // 0
      'Initial page not loaded',            // 1
      'The map is not yet created',         // 2
      'Not active',                         // 3
      'Can''t load resource',               // 4
      'This object has no relation in JavaScript', // 5
      'Id from JavaScript incorrect',       // 6
      'JavaScript Id does not exist',       // 7
      'Incorrect number of parameters',     // 8
      'Incorrect type parameter',           // 9
      'Incorrect value parameter',          // 10
      'Index out of range',                 // 11
      'Map not assigned',                   // 12
      'File does not exist',                // 13
      'The col number is incorrect'         // 14
      );

  Lang_FRE: array[0..14] of string = (
      'Navigateur Web non dfini',          // 0
      'Page initiale non charge',          // 1
      'La carte n''est pas encore cre',   // 2
      'Non actif',                          // 3
      'Ne peux pas charger la ressource',   // 4
      'Cet object n''a pas de relation dans JavaScript', // 5
      'Id JavaScript incorrect',            // 6
      'Id JavaScript inexistant',           // 7
      'Nombre incorrecte de paramtres',    // 8
      'Type de paramtre incorrect',        // 9
      'Valeur de paramtre incorrecte',     // 10
      'Indice hors limites',                // 11
      'Carte non attribue',                // 12
      'Le fichier n''existe pas',           // 13
      'Le numro de colonne est incorrect'  // 14
      );

  Lang_PTBR: array[0..14] of string = (
      'Navegador Web no definido',                // 0
      'Pgina inicial no foi carregada',          // 1
      'O mapa ainda no foi criado',               // 2
      'Inativo',                                   // 3
      'No  possvel carregar recursos',          // 4
      'Este objeto no tem relao em JavaScript', // 5
      'Id do JavaScript incorreto',                // 6
      'Id do JavaScript no existe',               // 7
      'Nmero incorreto de parmetros',            // 8
      'Tipo de parmetro incorreto',               // 9
      'Valor do parmetro incorreto',              // 10
      'ndice fora do intervalo',                  // 11
      'Mapa no atribudo',                        // 12
      'O arquivo no existe',                      // 13
      'O nmero da coluna est errado'             // 14
      );

  function GetTranslateText(Text: string; Lang: TLang): string;

implementation

{ TLanguage }

function GetTranslateText(Text: string; Lang: TLang): string;
  function GetIndex(Text: string): Integer;
  var
    i: Integer;
  begin
    Result := 0;
    for i := 1 to High(Lang_ESP) do
      if Text = Lang_ESP[i] then
      begin
        Result := i;
        Break;
      end;
  end;
begin
  case Lang of
    English: Result := Lang_ENG[GetIndex(Text)];
	  French: Result := Lang_FRE[GetIndex(Text)];
    PortuguesBR: Result := Lang_PTBR[GetIndex(Text)];
    else Result := Text;
  end;
end;

end.
